
#pragma once
#include "dusk.h"

typedef struct _entity_t entity_t;

#define NPC_INTERACT_TEXTS_MAX 4

typedef enum {
  NPC_INTERACT_TYPE_NONE = 0,
  NPC_INTERACT_TYPE_TEXT = 1,
  NPC_INTERACT_TYPE_CONVO = 2,
  NPC_INTERACT_TYPE_EVENT = 3,
} npcinteracttype_t;

typedef struct {
  npcinteracttype_t interactType;

  union {
    char_t* texts[NPC_INTERACT_TEXTS_MAX];
  };
} npc_t;

/**
 * Initializes the NPC entity.
 * 
 * @param entity The entity to initialize.
 */
void npcInit(entity_t *entity);

/**
 * Updates the NPC entity.
 * 
 * @param entity The entity to update.
 */
void npcUpdate(entity_t *entity);

/**
 * Handles interaction between the player and the NPC.
 * 
 * @param player The player entity interacting with the NPC.
 * @param self The NPC entity being interacted with.
 */
void npcInteract(entity_t *player, entity_t *self);